#include "stdafx.h"
#include "CAttachmentDropTargetApp.hpp"
#include "CAttachmentDropTargetCtrl.hpp"
#include "CAttachmentDropTargetPropPage.hpp"
#include "COleDropWndTarget.hpp"

#ifdef _DEBUG
#define new DEBUG_NEW
#endif

IMPLEMENT_DYNCREATE(CAttachmentDropTargetCtrl, COleControl)

// Mesage map.
BEGIN_MESSAGE_MAP(CAttachmentDropTargetCtrl, COleControl)
	ON_OLEVERB(AFX_IDS_VERB_PROPERTIES, OnProperties)
	ON_WM_CREATE()
END_MESSAGE_MAP()

// Dispatch map.
BEGIN_DISPATCH_MAP(CAttachmentDropTargetCtrl, COleControl)
	DISP_PROPERTY_EX_ID(
		CAttachmentDropTargetCtrl,
		"BlockSize",
		dispidBlockSize,
		GetBlockSize,
		SetBlockSize,
		VT_I4
	)
END_DISPATCH_MAP()

// Event map.
BEGIN_EVENT_MAP(CAttachmentDropTargetCtrl, COleControl)
	EVENT_CUSTOM_ID("FileAdded", eventidFileAdded, FileAdded, VTS_BSTR)
	EVENT_CUSTOM_ID("DataArrived", eventidDataArrived, DataArrived, VTS_VARIANT)
END_EVENT_MAP()

// Property pages.
// TODO:  When adding additional property pages increment the counter.
BEGIN_PROPPAGEIDS(CAttachmentDropTargetCtrl, 1)
	PROPPAGEID(CAttachmentDropTargetPropPage::guid)
END_PROPPAGEIDS(CAttachmentDropTargetCtrl)

// Initialize class factory and GUID.
IMPLEMENT_OLECREATE_EX(
	CAttachmentDropTargetCtrl,
	"ATTACHMENTDROPTA.AttachmentDropTaCtrl.1",
	0xbf4e6d7f, 0x3a0b, 0x43c5, 0xbd, 0x11, 0x3d, 0x70, 0xf9, 0xfc, 0x7e, 0x66
)

// ID und Version der Typbibliothek
IMPLEMENT_OLETYPELIB(CAttachmentDropTargetCtrl, _tlid, _wVerMajor, _wVerMinor)

// Interface identifiers.
const IID BASED_CODE IID_DAttachmentDropTarget =
	{0xB17D971, 0xFA4D, 0x447A, {0x85, 0x8C, 0x8, 0x4C, 0x5F, 0xEB, 0x29, 0x88}}
;
const IID BASED_CODE IID_DAttachmentDropTargetEvents =
	{0xD5FCE98, 0x945A, 0x49EA, {0x97, 0x1A, 0xBC, 0xEF, 0xD1, 0x31, 0x9B, 0xF3}}
;

// Information about the control type.
static const DWORD BASED_CODE _dwAttachmentDropTargetOleMisc =
	OLEMISC_ACTIVATEWHENVISIBLE |
	OLEMISC_SETCLIENTSITEFIRST |
	OLEMISC_INSIDEOUT |
	OLEMISC_CANTLINKINSIDE |
	OLEMISC_RECOMPOSEONRESIZE
;

IMPLEMENT_OLECTLTYPE(
	CAttachmentDropTargetCtrl,
	IDS_ATTACHMENTDROPTARGET,
	_dwAttachmentDropTargetOleMisc
)

//
// Adds registry entries for 'CAttachmentDropTargetCtrl' to the registry or
// removes them.
//
BOOL CAttachmentDropTargetCtrl::CAttachmentDropTargetCtrlFactory::UpdateRegistry(BOOL bRegister)
{

	// TODO:  Check if your control conforms to the apartment model threading
	// rules.  Further information can be found in the MFC TechNote 64.  If
	// the control does not conform to the apartment model rules, you must
	// adapt the code below by changing the value of the 6th parameter of
	// 'afxRegApartmentThreading' to 0.
	if (bRegister)
		return
			AfxOleRegisterControlClass(
				AfxGetInstanceHandle(),
				m_clsid,
				m_lpszProgID,
				IDS_ATTACHMENTDROPTARGET,
				IDB_ATTACHMENTDROPTARGET,
				afxRegApartmentThreading,
				_dwAttachmentDropTargetOleMisc,
				_tlid,
				_wVerMajor,
				_wVerMinor
			)
		;
	else
		return AfxOleUnregisterClass(m_clsid, m_lpszProgID);
}

CAttachmentDropTargetCtrl::CAttachmentDropTargetCtrl()
{
	InitializeIIDs(&IID_DAttachmentDropTarget, &IID_DAttachmentDropTargetEvents);
	
	// Initialize control.
	SetBlockSize(0x2000);
	LoadString(
		AfxGetInstanceHandle(),
		IDS_CONTROL_CAPTION,
		m_lpszCaption,
		sizeof(m_lpszCaption)
	);
}

int CAttachmentDropTargetCtrl::OnCreate(
	LPCREATESTRUCT lpCreateStruct
)
{
	if (CWnd::OnCreate(lpCreateStruct) == -1)
		return -1;

	// Register this objects drop target.
	BOOL fSuccess = m_OleWndDropTarget.Register(this);
	if (!fSuccess)
		MessageBox(_T("Registering OLE drop target failed."));
	return 0;
}

CAttachmentDropTargetCtrl::~CAttachmentDropTargetCtrl()
{
	//
}

void CAttachmentDropTargetCtrl::OnDraw(
	CDC *pdc,
	const CRect &rcBounds,
	const CRect &rcInvalid
)
{
	if (pdc == NULL)
		return;
	pdc->Rectangle(rcBounds);
	pdc->SelectStockObject(DEFAULT_GUI_FONT);
	pdc->DrawText(
		m_lpszCaption,
		lstrlen(m_lpszCaption),
		(LPRECT)(LPCRECT)rcBounds,
		DT_CENTER | DT_VCENTER | DT_SINGLELINE
	);
}

void CAttachmentDropTargetCtrl::DoPropExchange(
	CPropExchange *pPX
)
{
	ExchangeVersion(pPX, MAKELONG(_wVerMinor, _wVerMajor));
	COleControl::DoPropExchange(pPX);

	// TODO:  Call 'PX_' functions for each persistent user-defined property.
}

//
// Resets the control to the default state.
//
void CAttachmentDropTargetCtrl::OnResetState()
{

	// Resets standards found in 'DoPropExchange'.
	COleControl::OnResetState();
	
	// TODO:  Reset other control states here.
}

LONG CAttachmentDropTargetCtrl::GetBlockSize()
{
	AFX_MANAGE_STATE(AfxGetStaticModuleState());

	return m_BlockSize;
}

VOID CAttachmentDropTargetCtrl::SetBlockSize(LONG Value)
{
	AFX_MANAGE_STATE(AfxGetStaticModuleState());

	m_BlockSize = Value;
	SetModifiedFlag();
}