#pragma once

#include "afxole.h"
#include "COleDropWndTarget.hpp"

class CAttachmentDropTargetCtrl : public COleControl
{
	DECLARE_DYNCREATE(CAttachmentDropTargetCtrl)

// Construction.
public:
	CAttachmentDropTargetCtrl();

// Destruction.
protected:
	~CAttachmentDropTargetCtrl();

// Overrides.
public:
	virtual int OnCreate(LPCREATESTRUCT lpCreateStruct);
	virtual void OnDraw(CDC *pdc, const CRect &rcBounds, const CRect &rcInvalid);
	virtual void DoPropExchange(CPropExchange *pPX);
	virtual void OnResetState();

// Implementation.
protected:
	DECLARE_OLECREATE_EX(CAttachmentDropTargetCtrl)		// Class factory and GUID.
	DECLARE_OLETYPELIB(CAttachmentDropTargetCtrl)		// 'GetTypeInfo'.
	DECLARE_PROPPAGEIDS(CAttachmentDropTargetCtrl)		// Property page identifiers.
	DECLARE_OLECTLTYPE(CAttachmentDropTargetCtrl)		// Type name and various states.

	// Message map table.
	DECLARE_MESSAGE_MAP()

	// Dispatch map.
	DECLARE_DISPATCH_MAP()

	// Event map.
	DECLARE_EVENT_MAP()

// Dispatch and event identifiers.
public:
	enum
	{
		dispidBlockSize = 1,
		eventidDataArrived = 2L,
		eventidFileAdded = 1L
	};

	void FileAdded(LPCTSTR FileName)
	{
		FireEvent(eventidFileAdded, EVENT_PARAM(VTS_BSTR), FileName);
	}

	void DataArrived(VARIANT *Data)
	{
		FireEvent(eventidDataArrived, EVENT_PARAM(VTS_PVARIANT), Data);
	}

	LONG GetBlockSize(void);
	void SetBlockSize(LONG Value);

// Private members.
private:
	COleDropWndTarget m_OleWndDropTarget;
	BOOL ByteArrayToVariant(BYTE *pbSource, LONG cCount, VARIANT *pvDest);

	LONG m_BlockSize;
	TCHAR m_lpszCaption[100];
};